%define anolis_release 2

%bcond_with internet_test
%bcond_with optional_test

Summary:        A Perl interface to the World-Wide Web
Name:           perl-libwww-perl
Version:        6.67
Release:        %{anolis_release}%{?dist}
License:        GPL-1.0-or-later OR Artistic-1.0-Perl
URL:            https://metacpan.org/release/libwww-perl
Source0:        https://cpan.metacpan.org/authors/id/O/OA/OALDERS/libwww-perl-%{version}.tar.gz
# Normalize shelbangs, not suitable for an upstream
Patch0:         libwww-perl-6.39-Normalize-shebangs-in-examples.patch
BuildArch:      noarch

BuildRequires:  coreutils findutils make
BuildRequires:  perl-generators perl-interpreter
BuildRequires:  perl(:VERSION) >= 5.8.1 perl(CPAN::Meta::Requirements) >= 2.120620
BuildRequires:  perl(ExtUtils::MakeMaker) >= 6.76
BuildRequires:  perl(File::Copy) perl(Getopt::Long) perl(Module::Metadata) perl(strict) perl(warnings)

# Run-time:
BuildRequires:  perl(Carp)

BuildRequires:  perl(Digest::MD5) perl(Encode) >= 2.12 perl(Encode::Locale) perl(Exporter) perl(File::Temp)

BuildRequires:  perl(IO::Select)
BuildRequires:  perl(IO::Socket)

BuildRequires:  perl(LWP::MediaTypes) >= 6

BuildRequires:  perl(HTML::Entities) perl(HTML::HeadParser) perl(HTTP::Config) perl(HTTP::Cookies) >= 6 perl(HTTP::Date) >= 6
BuildRequires:  perl(HTTP::Headers::Util) perl(HTTP::Request) >= 6 perl(HTTP::Request::Common) >= 6 perl(HTTP::Response) >= 6 perl(HTTP::Status) >= 6.07
BuildConflicts: perl(HTTP::Status) = 6.17

BuildRequires:  perl(MIME::Base64) >= 2.1

BuildRequires:  perl(Net::HTTP) >= 6.18

BuildRequires:  perl(parent) >= 0.217 perl(Scalar::Util) perl(Try::Tiny)

BuildRequires:  perl(URI) >= 1.10
BuildRequires:  perl(URI::Escape)

BuildRequires:  perl(WWW::RobotRules) >= 6

# Tests:
BuildRequires:  perl(Config) perl(File::Spec) perl(FindBin) perl(HTTP::Daemon) >= 6.01 perl(Test::Fatal) perl(Test::More) >= 0.96
%if %{with internet_test}
BuildRequires:  perl(Test::RequiresInternet)
%endif

BuildRequires:  perl(utf8)
%if %{with internet_test}
BuildRequires:  perl(Test::Needs)
%if %{with optional_test}
BuildRequires:  perl(Test::LeakTrace)
%endif
%endif

Requires:       perl(Authen::NTLM) >= 1.02  perl(Encode) >= 2.12 perl(File::Spec) perl(File::Listing) >= 6 

Requires:       perl(HTML::Entities) perl(HTML::HeadParser)
Requires:       perl(HTTP::Config) perl(HTTP::Cookies) >= 6 perl(HTTP::Date) >= 6 perl(HTTP::Headers::Util)
Requires:       perl(HTTP::Negotiate) >= 6 perl(HTTP::Request) >= 6 perl(HTTP::Request::Common) >= 6 perl(HTTP::Response) >= 6
Requires:       perl(HTTP::Status) >= 6.07 perl(LWP::MediaTypes) >= 6 perl(MIME::Base64) >= 2.1
Requires:       perl(Net::FTP) >= 2.58 perl(Net::HTTP) >= 6.18 perl(URI) >= 1.10 perl(URI::Escape)
Requires:       perl(WWW::RobotRules) >= 6

Suggests:       perl(CPAN::Config) perl(HTML::FormatPS) perl(HTML::FormatText)  perl(HTML::Parse)  perl(LWP::Protocol::https) >= 6.02

Provides:       perl(LWP::Debug::TraceHTTP::Socket) = %{version}
Provides:       perl(LWP::Protocol::http::Socket) = %{version}
Provides:       perl(LWP::Protocol::http::SocketMethods) = %{version}

# Remove underspecified dependencies
%global __requires_exclude %{?__requires_exclude:%{__requires_exclude}|}^perl\\((Authen::NTLM|Encode|File::Listing|HTTP::Cookies|HTTP::Daemon|HTTP::Date|HTTP::Negotiate|HTTP::Request|HTTP::Response|HTTP::Status|LWP::MediaTypes|MIME::Base64|Net::FTP|Net::HTTP|Test::More|URI|WWW::RobotRules)\\)$

%description
The libwww-perl collection is a set of Perl modules which provides a simple and
consistent application programming interface to the World-Wide Web.  The main
focus of the library is to provide classes and functions that allow you to
write WWW clients. The library also contain modules that are of more general
use and even classes that help you implement simple HTTP servers.

The library includes modules for common web-related tasks like HTTP requests,
parsing HTML and XML documents, and managing cookies and authentication. It
also supports protocols like FTP, NNTP, and Telnet.

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       coreutils
Requires:       perl-Test-Harness
Requires:       perl(HTTP::Cookies) >= 6
Requires:       perl(HTTP::Daemon) >= 6.01
Requires:       perl(HTTP::Request) >= 6
Requires:       perl(HTTP::Response) >= 6
Requires:       perl(Net::HTTP) >= 6.18
Requires:       perl(Test::More) >= 0.96
Requires:       perl(URI) >= 1.10
%if %{with internet_test} && %{with optional_test}
Requires:       perl(Test::LeakTrace)
%endif

%description tests
Tests from %{name}. Execute them
with "%{_libexecdir}/%{name}/test".

%package doc
Summary:        Documentation for %{name}
Requires:       %{name} = %{?epoch:%{epoch}:}%{version}-%{release}
BuildArch:      noarch

%description doc
Documentation for %{name}.

%prep
%autosetup -p1 -n libwww-perl-%{version}
%if %{without internet_test}
rm t/base/protocols/nntp.t t/leak/no_leak.t t/redirect.t
sed -i -e '/^t\/base\/protocols\/nntp\.t/d' -e '/^t\/leak\/no_leak\.t/d' -e '/^t\/redirect\.t/d' MANIFEST
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1 --aliases < /dev/null
%make_build

%install
%make_install
%{_fixperms} %{buildroot}/*
# Install tests
mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t talk-to-ourself %{buildroot}%{_libexecdir}/%{name}
cat > %{buildroot}%{_libexecdir}/%{name}/test << 'EOF'
#!/bin/bash
set -e
# t/local/http.t writes to CWD
DIR=$(mktemp -d)
cp -a %{_libexecdir}/%{name}/* "$DIR"
pushd "$DIR"
unset COVERAGE PERL_LWP_ENV_HTTP_TEST_SERVER_TIMEOUT PERL_LWP_ENV_HTTP_TEST_URL
prove -I . -j "$(getconf _NPROCESSORS_ONLN)" -r
popd
rm -r "$DIR"
EOF
chmod +x %{buildroot}%{_libexecdir}/%{name}/test

%check
make test

%files
%license LICENSE
%doc examples README.SSL
%{_bindir}/*
%{perl_vendorlib}/*
%{_mandir}/man1/*.1*
%{_mandir}/man3/*.3*

%files tests
%{_libexecdir}/%{name}

%files doc
%doc Changes INSTALL MANIFEST

%changelog
* Wed Apr 12 2023 Kun(llfl) <llfl@linux.alibaba.com> - 6.67-2
- optimize spec file

* Wed Feb 01 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 6.67-1
- init from upstream
